
!SystemDictionary methodsFor: '*All' stamp: 'hjo 12/24/2008 14:14'!
allClassesAndMetaclasses

	^self allClasses , self allMetaclasses
! !

!SystemDictionary methodsFor: '*All' stamp: 'hjo 12/24/2008 14:15'!
allClassesThatCanUnderstandAllOf: arrayOfSelectors

	^(self allClassesAndMetaclasses
		select: [:e| arrayOfSelectors allSatisfy: [:s| e canUnderstand:s]]) asArray! !

!SystemDictionary methodsFor: '*All' stamp: 'hjo 12/24/2008 14:13'!
allMetaclasses

	^self allClasses collect: [:c| c class ]
! !

!SystemDictionary methodsFor: '*All' stamp: 'HwaJong 12/17/2012 17:09'!
reductionOfAllClasses: arrayOfClasses
	| classes canBeRemoved classCount |
	classes := arrayOfClasses.
	classCount := classes size.
	[ 
	canBeRemoved := OrderedCollection new.
	classes
		do: [ :each | 
			| s |
			s := each subclasses.
			(classes includesAllOf: s)
				ifTrue: [ canBeRemoved addAll: s ] ].
	classes := classes copyWithoutAll: canBeRemoved.
	classes size < classCount ] whileTrue: [ classCount := classes size ].
	^ classes! !

!SystemDictionary methodsFor: '*All' stamp: 'HwaJong 12/17/2012 17:10'!
reductionOfAllClassesThatCanUnderstandAllOf: arrayOfSelectors
	^self reductionOfAllClasses: 
		(self allClassesThatCanUnderstandAllOf: arrayOfSelectors)! !

!SmalltalkImage methodsFor: '*All' stamp: 'hjo 1/14/2012 17:47'!
allMethods

	^Array streamContents: [:stream|
		self allClasses do: [:class|
				stream nextPutAll:  class methodDictionary values.
				stream nextPutAll:  class class methodDictionary values.
			]
		]  ! !

!SmalltalkImage methodsFor: '*All' stamp: 'hjo 6/11/2011 13:27'!
allObjects

	| topClasses |
	topClasses := self allClasses select: [:cl| cl superclass isNil ].
	^Array streamContents: [:stream| 
		topClasses do: [:each| stream nextPutAll: each allSubInstances ]  ].! !

!SmalltalkImage methodsFor: '*All' stamp: 'hjo 6/11/2011 11:24'!
allObjectsThatCanRespondToAllOf: arrayOfSelectors

	^(((self systemNavigation environment) reductionOfAllClassesThatCanUnderstandAllOf: arrayOfSelectors) collect: [:class| class allSubInstances]) concatenateAll.! !

!SmalltalkImage methodsFor: '*All' stamp: 'hjo 9/22/2011 12:02'!
allPragmas

	^(self allMethods gather: #pragmas) asSet.! !
